/**
 *  FileLog
 *
 *  Copyright (C) 2006-2014 Teru Kamogashira
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef __FileLog_H
#define __FileLog_H

#include <cstdio>
#include <cstdarg>
#include <string>

class FileLog
{
public:
  FileLog();
  ~FileLog();
  void setLogFileName(char * filename);
  void writeLogA(const char * fmt, ...);
  void writeDumpA(const char * description, const unsigned char * data, int size);
  
private:
  std::string logFilename;
};

#endif
